<template>
  <div class="dateTimeInput">
    <div class="dateTimeInput__left">
      <div class="dateTimeInput__label">
        {{ label }}
      </div>
      <div class="dateTimeInput__content">
        <input
          ref="day"
          v-model="day"
          v-int
          class="dateTimeInput__input dateTimeInput__input--day"
          :style="dayWidth"
          type="text"
          placeholder="дд"
          @input="updateField('day', 'month', 4)"
          @focus="$refs.day.select()"
          @blur="day = day.padStart(2, 0)"
          @keydown.right="onCursorRight($event, 'month')"
        />
        <span class="dateTimeInput__divider">.</span>
        <input
          ref="month"
          v-model="month"
          v-int
          class="dateTimeInput__input dateTimeInput__input--month"
          :style="monthWidth"
          type="text"
          placeholder="мм"
          @input="updateField('month', 'year', 2)"
          @focus="$refs.month.select()"
          @blur="month = month.padStart(2, 0)"
          @keydown.left="onCursorLeft($event, 'day')"
          @keydown.right="onCursorRight($event, 'year')"
        />
        <span class="dateTimeInput__divider">.</span>
        <input
          ref="year"
          v-model="year"
          v-int
          class="dateTimeInput__input dateTimeInput__input--year"
          :style="yearWidth"
          type="text"
          placeholder="гггг"
          @focus="$refs.year.select()"
          @blur="year = year.padStart(4, 0)"
          @input="updateField('year', 'hour', 9999)"
          @keydown.left="onCursorLeft($event, 'month')"
          @keydown.right="isTime ? onCursorRight($event, 'hour') : ''"
        />
        <span class="dateTimeInput__divider" v-if="isTime">,</span>
        <input
          v-if="isTime"
          ref="hour"
          v-model="hour"
          v-int
          type="text"
          placeholder="чч"
          class="dateTimeInput__input dateTimeInput__input--hour"
          :style="hourWidth"
          @input="updateField('hour', 'minutes', 3)"
          @focus="$refs.hour.select()"
          @blur="hour = hour.padStart(2, 0)"
          @keydown.left="onCursorLeft($event, 'year')"
          @keydown.right="onCursorRight($event, 'minutes')"
        />
        <span class="dateTimeInput__divider" v-if="isTime">:</span>
        <input
          v-if="isTime"
          ref="minutes"
          v-model="minutes"
          v-int
          type="text"
          placeholder="мм"
          class="dateTimeInput__input dateTimeInput__input--minutes"
          :style="minutesWidth"
          @input="updateField('minutes', 'minutes', 6)"
          @focus="$refs.minutes.select()"
          @blur="minutes = minutes.padStart(2, 0)"
          @keydown.left="onCursorLeft($event, 'hour')"
        />
      </div>
    </div>
    <div class="dateTimeInput__right">
      <div class="dateTimeInput__icon" v-if="!isValid">
        <ObTooltip
          class="dateTimeInput__error"
          :content="errorMessage"
          type="error"
          position="top-end"
        >
          <i class="icon alert" />
        </ObTooltip>
      </div>
    </div>
  </div>
</template>

<script>
import ObTooltip from "common-components/src/obComponents/obTooltip";
export default {
  name: "dateTimeInput",

  components: {
    ObTooltip
  },

  props: {
    value: {
      type: [Number, String, Date],
      required: true
    },

    label: {
      type: String,
      default: "Label"
    },

    isTime: {
      type: Boolean,
      default: false
    },

    icon: {
      type: String,
      default: "calendar"
    },

    isValid: {
      type: Boolean,
      default: true
    },

    errorMessage: {
      type: String
    },

    blockDaysBeforeToday: {
      type: Boolean,
      default: false
    },

    dataQa: {
      type: String
    }
  },

  data() {
    return {
      day: "",
      month: "",
      year: "",
      hour: "",
      minutes: ""
    };
  },

  computed: {
    isCurrentDay() {
      const curMonth = new Date().getMonth() + 1;
      const curDay = new Date().getDate();
      const valueMonth = +this.month;
      const valueDay = +this.day;
      return curMonth === valueMonth && curDay === valueDay;
    },

    dayWidth() {
      if (this.day.length > 0) {
        return `width: ${(this.day.length + 1) * 6}px`;
      }
      return `width: ${(this.$refs.day.getAttribute("placeholder").length + 1) *
        8}px`;
    },

    monthWidth() {
      if (this.month.length > 0) {
        return `width: ${(this.month.length + 1) * 6}px`;
      }
      return `width: ${(this.$refs.month.getAttribute("placeholder").length +
        1) *
        8}px`;
    },

    yearWidth() {
      if (this.year.length > 0) {
        return `width: ${(this.year.length + 1) * 8}px`;
      }
      return `width: ${(this.$refs.year.getAttribute("placeholder").length +
        1) *
        8}px`;
    },

    hourWidth() {
      if (this.hour.length > 0) {
        return `width: ${(this.hour.length + 1) * 6}px`;
      }
      return `width: ${(this.$refs.hour.getAttribute("placeholder").length +
        1) *
        8}px`;
    },

    minutesWidth() {
      if (this.minutes.length > 0) {
        return `width: ${(this.minutes.length + 1) * 6}px`;
      }
      return `width: ${(this.$refs.minutes.getAttribute("placeholder").length +
        1) *
        8}px`;
    },

    timestamp() {
      return this.isTime ? Date.parse(`${this.year.padStart(4, 0)}-${this.month}-${this.day}T${this.hour}:${this.minutes}`) : Date.parse(`${this.year.padStart(4, 0)}-${this.month}-${this.day}`);
    }
  },

  watch: {
    day(current, prev) {
      if (this.blockDaysBeforeToday && current.length === 2) {
        const curMonth = new Date().getMonth() + 1;
        const curDay = new Date().getDate();
        if (+this.month === curMonth && +current < curDay) {
          if (prev == 0) {
            this.day = (curDay + "").padStart(2, 0);
          } else {
            this.day = prev;
          }
          this.$refs.month.select();
        }
      }
    },

    month(current, prev) {
      const cur = Date.parse(new Date());

      if (this.timestamp < cur) {
        this.month = prev;
      }
    },

    year(current, prev) {
      const curYear = new Date().getFullYear();
      if (current > 9999) {
        this.year = prev;
        this.$refs.hour.select();
      }
      if (current.length === 4 && +current < curYear) {
        this.year = (curYear + "").padStart(4, 0);
        this.$refs.hour.select();
      }
    },

    minutes(current, prev) {
      if (current > 60) this.minutes = prev;
    },

    value: {
      handler(newVal) {
        const day = newVal ? new Date(newVal).getDate() + "" : "";
        const month = newVal ? new Date(newVal).getMonth() + 1 + "" : "";
        this.day = day.padStart(2, 0);
        this.month = month.padStart(2, 0);
        this.year = `${newVal ? new Date(newVal).getFullYear() : ""}`;
        if (this.isTime) {
          const hour = newVal ? new Date(newVal).getHours() + "" : "";
          const minutes = newVal ? new Date(newVal).getMinutes() + "" : "";

          const curMinutes = new Date().getMinutes();
          const curHour = new Date().getHours();

          if (this.isCurrentDay && +curHour + 3 > hour) {
            this.hour = (+curHour + 3 + "").padStart(2, 0);
            this.minutes = (curMinutes + "").padStart(2, 0);
          } else {
            this.hour = hour.padStart(2, 0);
            this.minutes = minutes.padStart(2, 0);
          }
        }
      },
      deep: true,
      immediate: true
    }
  },

  methods: {
    onCursorLeft(e, prevField) {
      if (e.target.selectionStart === 0) {
        this.$refs[prevField].select();
      }
    },

    onCursorRight(e, nextField) {
      if (e.target.selectionStart === 2 && nextField !== "hour") {
        this.$refs[nextField].select();
      }
      if (e.target.selectionStart === 4 && nextField === "hour") {
        this.$refs[nextField].select();
      }
    },

    updateValue() {
      const cur = Date.parse(new Date());

      if (Number.isNaN(this.timestamp)) return;

      if (this.timestamp < cur) return;
      this.$emit("input", this.timestamp);
    },

    updateField(field, nextField, max) {
      if (!this[field].length || parseInt(this[field], 10) < max) return;
      this.$refs[nextField].select();
      this.updateValue();
    }
  },

  directives: {
    int: {
      bind: function(el) {
        el.addEventListener("keydown", e => {
          if (
            [46, 8, 9, 27, 13].indexOf(e.keyCode) !== -1 ||
            // Allow: Ctrl+A
            (e.keyCode === 65 && e.ctrlKey === true) ||
            // Allow: Ctrl+C
            (e.keyCode === 67 && e.ctrlKey === true) ||
            // Allow: Ctrl+X
            (e.keyCode === 88 && e.ctrlKey === true) ||
            // Allow: home, end, left, right
            (e.keyCode >= 35 && e.keyCode <= 39)
          ) {
            // let it happen, don't do anything
            return;
          }
          // Ensure that it is a number and stop the keypress
          if (
            (e.shiftKey || e.keyCode < 48 || e.keyCode > 57) &&
            (e.keyCode < 96 || e.keyCode > 105)
          ) {
            e.preventDefault();
          }
        });
      }
    }
  }
};
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";
@import "~common-components/src/static/css/mixins";

.dateTimeInput {
  display: flex;
}
.dateTimeInput__left {
  display: flex;
  flex-direction: column;
  flex-grow: 1;
}
.dateTimeInput__label {
  @include font-mixin(12px, 16px, 400, $color-grey-label, 0.4);
}
.dateTimeInput__content {
  display: flex;
  align-items: flex-end;
}
.dateTimeInput__input {
  width: auto;
  border: none;
  text-align: center;
  -moz-appearance: textfield;
  font-family: Roboto, sans-serif;
  font-style: normal;
  font-weight: normal;
  font-size: 16px;
  line-height: 20px;
  letter-spacing: 0.2px;
  text-align: left;

  &::-webkit-inner-spin-button {
    display: none;
  }

  &:focus {
    outline: none;
  }
}
.dateTimeInput__divider {
  pointer-events: none;
  width: 0.5em;
  text-align: center;
  position: relative;
  top: -2px;
}
.dateTimeInput__right {
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
}
.dateTimeInput__icon {
  font-size: 24px;
  color: $color-blue-navy-blue;
  cursor: pointer;

  &:hover {
    opacity: 0.8;
  }
}
.dateTimeInput__error {
  margin-left: 5px;
  color: $color-error;
}
</style>
